#ifndef _TURMA_HPP_
#define _TURMA_HPP_

#include <iostream>
#include <vector>
#include <ctime>
#include "HorarioAula.hpp"
#include "Serie.hpp"
#include "Professor.hpp"

class Turma
{
private:
    int codigo;
    int vagas;
    int ano;
    int semestre;
    std::tm dtInicio;
    std::tm dtFim;

    static int qtdTurmas;

    std::vector<HorarioAula*>* horarioAula;
    Serie* serie;
    Professor* professor;

public:
    Turma();
    ~Turma();
    Turma(int codigo, int vagas, int ano, int semestre, std::tm dtInicio, std::tm dtFim);

    int getCodigo();
	void setCodigo(int codigo);
	int getVagas();
	void setVagas(int vagas);
	int getAno();
	void setAno(int ano);
	int getSemestre();
	void setSemestre(int semestre);
	std::tm getDtInicio();
	void setDtInicio(std::tm dtInicio);
	std::tm getDtFim();
	void setDtFim(std::tm dtFim);
	int getQtdTurmas();

	std::vector<HorarioAula*>* getHorarioAula();
	void setHorarioAula(std::vector<HorarioAula*>* horarioAula);
	void adicionaHorarioAula(HorarioAula* horarioAula);
	Serie* getSerie();
	void setSerie(Serie* serie);
	Professor* getProfessor();
	void setProfessor(Professor* professor);

	void alocarProfessor(Professor* professor);
};

#endif