#include <iostream>
#include <ctime>

#include "bib/Aluno.hpp"
#include "bib/Curso.hpp"
#include "bib/HorarioAula.hpp"
#include "bib/Idioma.hpp"
#include "bib/Matricula.hpp"
#include "bib/Professor.hpp"
#include "bib/Serie.hpp"
#include "bib/Turma.hpp"


int main ( ) {
    Aluno *aluno1, *aluno2, *aluno3;
    Curso *curso1, *curso2, *curso3;
    HorarioAula *horarioAula1, *horarioAula2, *horarioAula3;
    Idioma *idioma1, *idioma2, *idioma3;
    Matricula *matricula1, *matricula2, *matricula3;
    Professor *professor1, *professor2, *professor3;
    Serie *serie1, *serie2, *serie3;
    Turma *turma1, *turma2, *turma3;

    std::time_t rawtime;
    std::time (&rawtime);
    std::tm dataTM = *(localtime(&rawtime));

    aluno1 = new Aluno("Um", 1, "Um", "Um", "Um", "Um", "Um", "Um");
    curso1 = new Curso(1, "Um");
    horarioAula1 = new HorarioAula("Um", rawtime, rawtime, 1);
    idioma1 = new Idioma("Um", 1);
    matricula1 = new Matricula(1, dataTM, 1, "Um");
    professor1 = new Professor(dataTM, dataTM, "Um", "Um", "Um", "Um", "Um", "Um");
    serie1 = new Serie(1);
    turma1 = new Turma(1, 1, 1, 1, dataTM, dataTM);

    aluno2 = new Aluno("Dois", 2, "Dois", "Dois", "Dois", "Dois", "Dois", "Dois");
    curso2 = new Curso(2, "Dois");
    horarioAula2 = new HorarioAula("Dois", rawtime, rawtime, 2);
    idioma2 = new Idioma("Dois", 2);
    matricula2 = new Matricula(2, dataTM, 2, "Dois");
    professor2 = new Professor(dataTM, dataTM, "Dois", "Dois", "Dois", "Dois", "Dois", "Dois");
    serie2 = new Serie(2);
    turma2 = new Turma(2, 2, 2, 2, dataTM, dataTM);

    aluno3 = new Aluno("Tres", 3, "Tres", "Tres", "Tres", "Tres", "Tres", "Tres");
    curso3 = new Curso(3, "Tres");
    horarioAula3 = new HorarioAula("Tres", rawtime, rawtime, 3);
    idioma3 = new Idioma("Tres", 3);
    matricula3 = new Matricula(3, dataTM, 3, "Tres");
    professor3 = new Professor(dataTM, dataTM, "Tres", "Tres", "Tres", "Tres", "Tres", "Tres");
    serie3 = new Serie(3);
    turma3 = new Turma(3, 3, 3, 3, dataTM, dataTM);

    // Fazendo as ligacoes
    curso1->setIdioma(idioma1);
    serie1->setCurso(curso1);
    turma1->setSerie(serie1);
    turma1->adicionaHorarioAula(horarioAula1);

    curso2->setIdioma(idioma2);
    serie2->setCurso(curso2);
    turma2->setSerie(serie2);
    turma2->adicionaHorarioAula(horarioAula2);

    // Matriculando o aluno 
    aluno1->matricular(turma1);
    aluno1->matricular(turma2);

    // Alocando professor
    turma1->alocarProfessor(professor1);

    // Quantidades
    std::cout << "Alunos matriculados " << aluno1->qtdAlunos << std::endl;
    std::cout << "Professores contratados " << professor1->getQtdProfessores() << std::endl;
    std::cout << "Turmas criadas " << turma1->getQtdTurmas() << std::endl;

    // Horario individual
    aluno1->imprimeHorario();

    delete aluno1; delete aluno2; delete aluno3;
    delete curso1; delete curso2; delete curso3;
    delete horarioAula1; delete horarioAula2; delete horarioAula3;
    delete idioma1; delete idioma2; delete idioma3;
    delete matricula1; delete matricula2; delete matricula3;
    delete professor1; delete professor2; delete professor3;
    delete serie1; delete serie2; delete serie3;
    delete turma1; delete turma2; delete turma3;

    return (0);
}
